

//  Digital Dial Clock
//  http://www.brettoliver.org.uk
//
//  Copyright 2014 Brett Oliver
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program. If not, see http://www.gnu.org/licenses/
//
// 
// Based on the DCF77 library by Udo Klein
// http://blog.blinkenlight.net/experiments/dcf77/dcf77-library/
// http://blog.blinkenlight.net/experiments/dcf77/simple-clock/
//

#include <LedControl.h>
#include <dcf77.h>
#include <LiquidCrystal_I2C.h>
#include <Wire.h>
/*
 
 ***** These pin numbers will probably not work with your hardware *****
 pin 12 is connected to the DataIn 
 pin 11 is connected to the CLK 
 pin 10 is connected to LOAD 
 We have only a single MAX72XX.
 */
LedControl lc=LedControl(12,11,10,1);

/* we always wait a bit between updates of the display */
unsigned long delaytime=250;
//**********************
// set the LCD address to 0x27 for a 20 chars 4 line display
// Set the pins on the I2C chip used for LCD connections:
//                    addr, en,rw,rs,d4,d5,d6,d7,bl,blpol
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address


//**********************

const uint8_t dcf77_analog_sample_pin = 5;
const uint8_t dcf77_sample_pin = A1;  // A5 == d19 (DFC77 signal)changed from A5
const uint8_t dcf77_inverted_samples = 0;
const uint8_t dcf77_analog_samples = 0;

const uint8_t dcf77_monitor_pin = A0;  // A4 == d18 changed from A4

const int8_t timezone_offset = -1;  // GB is one hour behind CET/CEST

//*********************
//int UTCcheck = 0;
//int 30secstep = 0:
//int 30secstep1 = 0;

int retardOn = 0;
//int retardtens = 0;
//int retard = 0;
int infraredSwval = 0; // infrared value
int infraredSw = 17; // set A3 to input ( pin 13)
int retardcount = 0;
int pulsecount = 0; // pulse counts upto required number to step forward 1 hour
//int sumwinSwval = 0; // value of sumwinSw
//int sumwinSw = 13; // summer winter switch pin 13
int retardSw = 13; // winter retard switch pin 9
int retardSwval = 0; // value of retardSw
int advanceSw = 9; // summer advance switch pin 13
int advanceSwval = 0; // value of advanceSw
int pulseOn = 0; // 0 pulse off 1 pulse on (summer winter pulsing
int summertest = 0; // equals 1 for summertime and 0 for wintertime
int summerwinter = 0; // summer winter toggle
//int startextra = 0; // delays checking of extra pule intil start extra = 3
int extracount = 0; // where quartz seconds needs to miss a pulse
int hourextra = 00; // hour last miss pulse variable
int dayextra = 00; // day last miss pulse variable
int monthextra = 00; // month last miss pulse variable
int minuteextra = 00; // minute last miss pulse variable
int secondextra = 00; // second last miss pulse variable
int yearextra = 00;


int secondsnow = 0; // previous second
int yearmiss = 00;
int daymiss = 00; // day last extra pulse variable
int monthmiss = 00; // month last extra pulse variable
int secsmiss = 0; // works out is seconds need to an extra pulse or miss a pulse
int misscount = 0; // 1 ok 0 needs to miss a pulse 1 needs an extra pulse
int hourmiss = 00; // hour last extra pulse variable
int minutemiss = 00; // minute last extra pulse variable
int secondmiss = 00; // second last extra pulse variable
int intensity = 0; // 7 segment intensity
int ldr = A2; // LDR connected to analogue A2 pin
unsigned int ldrValue; // LDR value
//int hourchime = 9;
//int qtrchime = 6;

int signalQual = 0; // computed once per minute and indicates how well 
// the received signal matches the locally synthesized reference signal max 50
int monthval = 0;
int dayval = 0;
//int zero = 0;
int years = 0;
int months = 0;
int days = 0;
int hours2 = 0; //2nd 7 segment hour digit
int hours1 = 0; //1st 7 segment hour digit
int hours = 0;
int minutes2 = 0; //2nd 7 segment minute digit
int minutes1 = 0; //1st 7 segment minute digit
int minutes = 0;
int seconds2 = 0;  //2nd 7 segment seconds digit
int seconds1 = 0; //1st 7 segment seconds digit
int seconds = 0;
int secsval = 0;
int minsval = 0;
int hourval = 0;
int led30 = 2;
int tick = 3;
int tickctrl = 0;
int tickctrlpwr = 0;
int ticktockOn = 4;
//int led1day = 5;
int quartzmotor1 = HIGH;              // ledState used to set the quartz motor pin 7 initial state
int quartzmotor2 = LOW;              //  ledState used to set the quartz motor pin 8 initial state
int quartz01 =7;  //  Quartz clock motor pulse 01
int quartz02 =8;  //  Quartz clock motor pulse 02
int quartz03 =5;  //  Quartz clock motor pulse 03
int quartz04 =6;  //  Quartz clock motor pulse 04
//********************

namespace Timezone {
  uint8_t days_per_month(const DCF77_Clock::time_t &now) {
    switch (now.month.val) {
    case 0x02:
      // valid till 31.12.2399
      // notice year mod 4 == year & 0x03
      return 28 + ((now.year.val != 0) && ((bcd_to_int(now.year) & 0x03) == 0)? 1: 0);
    case 0x01: 
    case 0x03: 
    case 0x05: 
    case 0x07: 
    case 0x08: 
    case 0x10: 
    case 0x12: 
      return 31;
    case 0x04: 
    case 0x06: 
    case 0x09: 
    case 0x11:                                  
      return 30;
    default: 
      return 0;
    }
  }   

  void adjust(DCF77_Clock::time_t &time, const int8_t offset) {
    // attention: maximum supported offset is +/- 23h

    int8_t hour = BCD::bcd_to_int(time.hour) + offset;

    if (hour > 23) {
      hour -= 24;
      uint8_t day = BCD::bcd_to_int(time.day) + 1;
      if (day > days_per_month(time)) {
        day = 1;
        uint8_t month = BCD::bcd_to_int(time.month);
        ++month;
        if (month > 12) {
          month = 1;
          uint8_t year = BCD::bcd_to_int(time.year);                  
          ++year;
          if (year > 99) {
            year = 0;
          }
          time.year = BCD::int_to_bcd(year);
        }                
        time.month = BCD::int_to_bcd(month);
      }
      time.day = BCD::int_to_bcd(day);
    }

    if (hour < 0) {
      hour += 24;
      uint8_t day = BCD::bcd_to_int(time.day) - 1;
      if (day < 1) {
        uint8_t month = BCD::bcd_to_int(time.month);
        --month;
        if (month < 1) {
          month = 12;
          int8_t year = BCD::bcd_to_int(time.year);                  
          --year;
          if (year < 0) {
            year = 99;
          }
          time.year = BCD::int_to_bcd(year);
        }                
        time.month = BCD::int_to_bcd(month);
        day = days_per_month(time);
      }
      time.day = BCD::int_to_bcd(day);
    }

    time.hour = BCD::int_to_bcd(hour);
  }
}

uint8_t sample_input_pin() {
  const uint8_t sampled_data =
    dcf77_inverted_samples ^ (dcf77_analog_samples? (analogRead(dcf77_analog_sample_pin) > 200)
    : digitalRead(dcf77_sample_pin));

  digitalWrite(dcf77_monitor_pin, sampled_data);
  return sampled_data;
}

void setup() {
  digitalWrite(led30, HIGH); // turn 30 sec clocks off at start
  tickctrlpwr = 0;
 // digitalWrite(qtrchime, HIGH); // turn Qtr chime off at start
  //digitalWrite(hourchime, HIGH); // turn Hour chime off at start

  //****** 7 seg
  /*
   The MAX72XX is in power-saving mode on startup,
   we have to do a wakeup call
   */
  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,0);
  /* and clear the display */
  lc.clearDisplay(0);
  lc.setScanLimit(0, 7); // set to 8 digits

  lcd.begin(20,4);   // initialize the lcd for 20 chars 4 lines, turn on backlight 
  using namespace DCF77_Encoder;
  //*************
 // lcd.backlight(); // backlight on not needed as controlled by 7 MAX2719
  lcd.setCursor(0,0); //Start at character 0 on line 0
  lcd.print("  DCF77 Dial Clock  ");  





  //***************
  Serial.begin(9600);
  /*  Serial.println();
   Serial.println(F(" DCF77  Dial  Clock "));
   Serial.println(F("(c) Brett Oliver 2014"));
   Serial.println(F("http://www.brettoliver.org.uk"));
   Serial.println(F("Based on the DCF77 library by Udo Klein"));
   Serial.println(F("www.blinkenlight.net"));
   Serial.println();
   Serial.print(F("Sample Pin:     ")); 
   Serial.println(dcf77_sample_pin);
   Serial.print(F("Inverted Mode:  ")); 
   Serial.println(dcf77_inverted_samples);
   Serial.print(F("Analog Mode:    ")); 
   Serial.println(dcf77_analog_samples);
   Serial.print(F("Monitor Pin:    ")); 
   Serial.println(dcf77_monitor_pin);
   Serial.print(F("Timezone Offset:")); 
   Serial.println(timezone_offset);
   Serial.println();
   Serial.println();
   Serial.println(F("Initializing..."));
   */
  pinMode(dcf77_monitor_pin, OUTPUT);

  pinMode(dcf77_sample_pin, INPUT);
  digitalWrite(dcf77_sample_pin, HIGH);


  //*******************
 // pinMode(qtrchime, OUTPUT);
 // pinMode(hourchime, OUTPUT);
  pinMode(led30, OUTPUT);
  pinMode(tick, OUTPUT);
  
 // pinMode(led1day, OUTPUT);
  pinMode(quartz01, OUTPUT);
  pinMode(quartz02, OUTPUT);
  pinMode(quartz03, OUTPUT);
  pinMode(quartz04, OUTPUT);
  pinMode(ticktockOn, INPUT);
  //pinMode(17, INPUT); // infrared switch
  pinMode(advanceSw,INPUT);
  pinMode(retardSw,INPUT);
  pinMode(infraredSw,INPUT);
  //pinMode(infraredSw, INPUT); // infrared sensor output

  //*******************

  DCF77_Clock::setup();
  DCF77_Clock::set_input_provider(sample_input_pin);


  // Wait till clock is synced, depending on the signal quality this may take
  // rather long. About 5 minutes with a good signal, 30 minutes or longer
  // with a bad signal
  
  digitalWrite(tick, HIGH); // turns off "Tick Tock" while clock syncs
  
  
  for (uint8_t state = DCF77::useless;
         state == DCF77::useless || state == DCF77::dirty;
         state = DCF77_Clock::get_clock_state()) {

    // wait for next sec
    DCF77_Clock::time_t now;
    DCF77_Clock::get_current_time(now);

    // render one dot per second while initializing
    static uint8_t count = 0;
    Serial.print('.');
    ++count;
    if (count == 60) {
      count = 0;
      Serial.println();
    }
  }
}

void paddedPrint(BCD::bcd_t n) {
  Serial.print(n.digit.hi);
  Serial.print(n.digit.lo);
}
void LCDpaddedPrint(BCD::bcd_t n) { 
  lcd.print(n.digit.hi); 
  lcd.print(n.digit.lo); 
}

void loop() {

  DCF77_Clock::time_t now;

  DCF77_Clock::get_current_time(now);
  Timezone::adjust(now, timezone_offset);

  if (now.month.val > 0) {


    //***********
    // get month & day values
    dayval = now.day.val, DEC;
    monthval = now.month.val, DEC;
    // Serial.print(" day ");
    // Serial.print(now.day.val, DEC);
    //  Serial.print(" month ");
    //  Serial.print(now.month.val, DEC);
    //   Serial.print(' ');
    // get month & day values
    // Quartz clock driver
    // toggle Quartz drive 7 & 8 evey second
    secsmiss = seconds - secondsnow;

    if (secsmiss ==-59 || secsmiss ==-60 && seconds ==0) // takes account of seconds rollover -59 or leap second -60
    {
      secsmiss = 1;
    } 


    if (secsmiss >=1 && seconds !=60) // if zero or less seconds pulse need to be missed. Leap second missed if seconds = 60
    {
      secondsmotor (); // function steps quartz motor
    }

    /*
    if (secsmiss >1) // if extra second pulse required
     {
     delay(100); // add delay so seconds mtor can operate again in the same second
     secondsmotor (); // function steps quartz motor and adds extra pulse if secmiss is >1
     }
     
     */



    if (secsmiss < 1 || seconds == 60) //records time of extra sec second (quart motor needs to loose a second)

    {
      extracount = extracount + 1; //increment extra count total (1sec needs to miss pulse)
      hourextra = hours;
      minuteextra = minutes;
      secondextra = seconds;
      yearextra = years;
      monthextra = months;
      dayextra = days;

    }


    if (secsmiss > 1) //records time of miss second (quart motor needs to add a second)
    {
      misscount = misscount + 1; //increment Miss count total (1sec has missed extra pulse)
      hourmiss = hours;
      minutemiss = minutes;
      secondmiss = seconds;
      yearmiss = years;
      monthmiss = months;
      daymiss = days;

    } 



    secondsnow = seconds; 



    if (hours== 6 && minutes == 10 && seconds == 01) // resets miss second counter to 0 at 6:10:01
    {
      misscount = 0;
      extracount = 0;
    }


    // }
    // Enable below to analize missed pulses on serial monitor
    //Serial.print(" ");
    // Serial.print("secsmiss ");
    //  Serial.println(secsmiss);


    Serial.print("Slow Seconds ");
    Serial.print(misscount);
    Serial.print(" ");
    Serial.print(hourmiss);
    Serial.print(":");
    Serial.print(minutemiss);
    Serial.print(":");
    Serial.print(secondmiss);
    Serial.print(" ");
    Serial.print(daymiss);
    Serial.print("/");
    Serial.print(monthmiss);
    Serial.print("/");
    Serial.println(yearmiss);


    Serial.print("Fast Seconds ");
    Serial.print(extracount);
    Serial.print(" ");
    Serial.print(hourextra);
    Serial.print(":");
    Serial.print(minuteextra);
    Serial.print(":");
    Serial.print(secondextra);
    Serial.print(" ");
    Serial.print(dayextra);
    Serial.print("/");
    Serial.print(monthextra);
    Serial.print("/");
    Serial.println(yearextra);







    // end missing second pulse

    // ################################################################################ 
    
    
    // Mute Tick Tock on startup
    ticktockOn = digitalRead(04);// chimes are off on power up press "chime On" switch to lock on
    tickctrl = ticktockOn;
  if (tickctrl == 1 || tickctrlpwr == 1)
  {
    tickctrlpwr = 1;
   // lcd.setCursor(0, 2);
   // lcd.print("Chime On ");
  }


  // End Mute Tick Tock on startup  
    
 // Tick Tock
 
 if ( (seconds % 2) == 0 && tickctrlpwr == 1 )
 { 
    digitalWrite(tick, LOW); //play "Tick Tock" every even second (sound is under 2 secs duration)
 }
  else
  {
 digitalWrite(tick, HIGH); // odd seconds sound is off
  }
 

 
 
 // end Tick Tock    
    

    /*
 Serial.println(F("confirmed_precision [Hz], target_precision v,total_adjust [Hz], frequency [Hz]"));
     Serial.print(DCF77_Frequency_Control::get_confirmed_precision());
     Serial.print(F(", "));
     Serial.print(DCF77_Frequency_Control::get_target_precision());
     Serial.print(F(", "));
     Serial.print(DCF77_1_Khz_Generator::read_adjustment());
     Serial.print(F(", "));
     Serial.print(16000000L - DCF77_1_Khz_Generator::read_adjustment());
     Serial.print(F(" Hz, "));
     
     */

    //***************
    // signal quality

    //  signalQual = DCF77_Clock::get_prediction_match();
    //  if(signalQual == 255 || signalQual == 0 )
    //  {
    // signalQual = 00;
    //  }
    // else
    //{
    //  signalQual = (signalQual * 2) -1;
    //}
    // Serial.print (" Signal Match ");
    // Serial.print (signalQual);
    // Serial.print ("% ");

    // display 7 segment intensity value on LCD
    lcd.setCursor(0,2);
    //lcd.print("7 Seg Int ");
    lcd.print("Brightness ");
    segIntensity(intensity); // adds leading zero to 7 segment intensity

      // end display 7 segment intensity value on LCD   


    // #################################
    //LDR start

    ldrValue = analogRead(ldr);
    
   //  Serial.print (" LDR Value ");
   //  Serial.print (ldrValue, DEC);
   //  Serial.print (" ");
    intensityValue();
    // Serial.print ("Intensity ");
  //   Serial.print (intensity);
  //   Serial.print (" ");
     
    //LDR finish
    //#################################
    //Serial.print (now.second.val);
    // Serial.print (" ");
    lcd.setCursor(13,2);
    //lcd.print(" Wait  ");
    switch (DCF77_Clock::get_clock_state()) {
      // case DCF77::useless: Serial.print(F("useless ")); break;
      case DCF77::useless: 
      lcd.print(F(" Fail  ")); 
      break;
      // case DCF77::dirty:   Serial.print(F("dirty: ")); break;
      //  case DCF77::synced:  Serial.print(F("synced: ")); break;
      // case DCF77::locked:  Serial.print(F("locked: ")); break;
      case DCF77::dirty:   
      lcd.print(F(" Dirty ")); 
      break;
      case DCF77::synced:  
      lcd.print(F(" Sync'd")); 
      break;
      case DCF77::locked:  
      lcd.print(F(" Locked")); 
      break;
    }

    //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    // Get hours minutes and seconds variables
    hours = BCD::bcd_to_int(now.hour);


    minutes = BCD::bcd_to_int(now.minute);


    seconds = BCD::bcd_to_int(now.second);

    years = BCD::bcd_to_int(now.year);

    months = BCD::bcd_to_int(now.month);

    days = BCD::bcd_to_int(now.day);


    //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

    //LEDseconds(); // converts secsval to seconds
    // LEDminutes(); // converts minsval to minutes
    // LEDhours(); // converts hourval to minutes
    //LEDseconds1(); // converts seconds to 2 single digits for 7 segment seconds display
    seconds2 = floor(seconds/10); //gets 2nd seconds char from seconds for 7 segment display
    seconds1 = seconds - (seconds2 * 10); //gets 1st seconds char from seconds for 7 segment display

    minutes2 = floor(minutes/10); //gets 2nd seconds char from seconds for 7 segment display
    minutes1 = minutes - (minutes2 * 10); //gets 1st seconds char from seconds for 7 segment display

    hours2 = floor(hours/10); //gets 2nd seconds char from hours for 7 segment display
    hours1 = hours - (hours2 * 10); //gets 1st seconds char from hours for 7 segment display

    // start infrared detect #######################################
    int infraredSw = digitalRead(17); // reads infrared detector output
    Serial.print ("Infrared ");
    Serial.println (infraredSw);
    Serial.println ("");
    
    

if (infraredSw == 1) // turns displays on during the day if infrared detects movement

    {
      lc.shutdown(0, false); // turns on the 7 segment display
    //  lcd.backlight(); // backlight on not needed as controlled by MAX2719
      lcd.display(); //display on   

    }
    else if (infraredSw == 0) // turns displays off during the day unless infrared detects movement
    {
      lc.shutdown(0, true); // turns off the 7 segment display and puts it into standby mode
     // lcd.noBacklight(); // LCD backlight off not needed as controlled by MAX2719
      lcd.noDisplay(); //LCD display off 

    }
    // end infrared detect #######################################

    // shows 7 segment display if infrared detected or time is after 22:00 and before 08:00
    /* Set the brightness to a medium values */
    //lc.setIntensity(0,8);
    lc.setIntensity(0,intensity); // set 7 segment intensity to value of "intensity"
   // lc.setScanLimit(0, 5);
    /* and clear the display */
    // lc.clearDisplay(0); 
    lc.setChar(0,7,seconds1,false); // print 1st seconds digit on 7 segment display and "false" turns DP off
    lc.setChar(0,6,seconds2,false); // print 2nd seconds digit on 7 segment display and "false" turns DP off
    lc.setChar(0,5,'o',false); // print lower case O on 7 segment display and "false" turns DP off tape mask shows :
    lc.setChar(0,4,minutes1,false); // print 1st minutes digit on 7 segment display and "false" turns DP off
    lc.setChar(0,3,minutes2,false); // print 2nd minutes digit on 7 segment display and "false" turns DP off
    lc.setChar(0,2,'o',false); // print lower case O on 7 segment display and "false" turns DP off tape mask shows :
    lc.setChar(0,1,hours1,false); // print 1st minutes digit on 7 segment display and "false" turns DP off
    lc.setChar(0,0 ,hours2,false); // print 2nd minutes digit on 7 segment display and "false" turns DP off
   

    /*  Serial.print (" H,M,S ");
     Serial.print (hours2);
     
     Serial.print (hours1);
     Serial.print (":");
     
     
     Serial.print (minutes2);
     
     Serial.print (minutes1);
     Serial.print (":");
     
     
     Serial.print (seconds2);
     
     Serial.print (seconds1);
     Serial.print (":");
     
     */
    lcd.setCursor(6,3);



    // 7 segment


    //****************

    lcd.setCursor(0,0);

    LCDpaddedPrint(now.hour);
    lcd.print(":");
    LCDpaddedPrint(now.minute);
    lcd.print(":");
    LCDpaddedPrint(now.second);
    lcd.print("  ");

    LCDpaddedPrint(now.day);
    lcd.print("/");
    LCDpaddedPrint(now.month);
    lcd.print("/");
    lcd.print("20");
    LCDpaddedPrint(now.year);





    //****************
    /*
    
     paddedPrint(now.hour);
     Serial.print(':');
     paddedPrint(now.minute);
     Serial.print(':');
     paddedPrint(now.second);
     Serial.print(' ');
     
     paddedPrint(now.day);
     Serial.print('/');
     paddedPrint(now.month);
     Serial.print('/');
     Serial.print(F("20"));
     paddedPrint(now.year);
     
     
     */



    // const int8_t offset_to_utc = timezone_offset + now.uses_summertime? 2: 1;
    const int8_t offset_to_utc = timezone_offset + (now.uses_summertime? 2: 1);

    // Serial.print(F(" GMT"));

    summertest = (abs(offset_to_utc)); // equals 1 if summertime and 2 if wintertime 

    if (summertest ==2) // if wintertime make summertest =0
    {
      summertest = 0;
    }

    //**************
    lcd.setCursor(15,3);
    lcd.print("GMT+");
    // UTCcheck= offset_to_utc;
    // lcd.print(UTCcheck);
    lcd.print(summertest);
    //**************




    //  Serial.print(offset_to_utc<0? '-':'+');
    // lcd.print(offset_to_utc<0? '-':'+');
    //  if (abs(offset_to_utc) < 10) {
    //     Serial.print('0');
    //  lcd.print('0');
    //   }
    //   Serial.println(summertest);
  }

  //*******************
  // secsval = (now.second.val);
  //  minsval = (now.minute.val);
  //  hourval = (now.hour.val);

  // Serial.print ("Secs Val ");
  //  Serial.print (secsval);
  //  Serial.print (" Min Val ");
  //  Serial.print (minsval);
  //  Serial.print (" Hr Val ");
  //  Serial.print (hourval);



  /*
  // Quater chime
  if (( minutes ==15 || minutes ==30 || minutes==45) && seconds==0)
  {
    digitalWrite(qtrchime, LOW);
    // lc.clearDisplay(0); // Test reset LED display on Qtr Chime to pevent corrupted display
  }

  else if (minutes ==59 && seconds==57)
  {
    digitalWrite(qtrchime, LOW);
  }
  else digitalWrite(qtrchime, HIGH);
  // End quater chime
  */
  
  /*
 // Hour chime
 // map hours to range 1-12
    const uint8_t normalized_hours = hours > 12 ? hours-12 : hours > 0 ? hours : 12;
 // compute chime instead of matching it
    digitalWrite(hourchime,minutes == 0 && (seconds & 1) == 0 && seconds< 2 * normalized_hours);
 
 
 
  // End Hour chime
  */
 
  //$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
  // Quality display on LCD


  if (seconds >= 0 && seconds <= 12)
  { 
    signalmatch(); // Quality factor
  }

  else if (seconds == 15)
  {
    blankrow3(); //Blanks row 3
  }

else if (seconds == 16)
  {
    lcd.setCursor(0,3);
  lcd.print("Quartz         ");
  }
  else if (seconds >= 17 && seconds <= 37)
  {
    precision(); //quartz confirmed and target precision
  }

  else if (seconds == 38)
  {
    blankrow3(); //Blanks row 3
  }

 else if (seconds >= 39 && seconds <= 40)
  {
      lcd.setCursor(0,3);
  lcd.print("Frequency      ");
  }

  else if (seconds >= 41 && seconds <= 58)
  {
    freqadj(); //frequency adjustment and actual frequency
  }

  else if (seconds == 59)
  {
    blankrow3(); //Blanks row 3
  }
 
  // End of Quality display on LCD
  //$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$



  // winter to summer change // clocks go forward#################################
  advanceSwval = digitalRead(advanceSw);   // read advanceSw switch

  if (pulsecount < 120 && (seconds == 0 || seconds == 30) && (advanceSwval == 1 || pulseOn == 1))
    // summertest is 1 in summertime and  0 in wintertime  advance on 00 & 30 secs does not advance pulse count

  {
    // sumwinSwval = 1;
    pulseOn = 1;
    //Serial.println(" 30 second test ");

    digitalWrite(led30, LOW);   // turn the PULSE ON trigger mono stable (HIGH is the voltage level)
    delay(10);
    digitalWrite(led30, HIGH);   // turn the PULSE OFF trigger mono stable(HIGH is the voltage level)

  }

  else if (pulsecount < 120 && (advanceSwval == 1 || pulseOn == 1)) // summertest is 1 in summertime and  0 in wintertime 

  {
    // sumwinSwval = 1;
    pulseOn = 1;
    pulsecount = pulsecount + 1;

    digitalWrite(led30, LOW);   // turn the PULSE ON trigger mono stable (HIGH is the voltage level)
    delay(10);
    digitalWrite(led30, HIGH);   // turn the PULSE OFF trigger mono stable(HIGH is the voltage level)
  }

  else  
  {
    pulseOn = 0; // 
    // sumwinSwval = 0;
    pulsecount = 0;
  } 

  // end winter to summer chaange advance ##############################



  //  summer to winter change clocks go back#################################
  retardSwval = digitalRead(retardSw);   // read retardSw switch

  if (retardcount < 120 && retardSwval == 1) 
  {
    retardOn = 1;
  }

  else if (retardcount < 120 && (seconds == 0 || seconds == 30) && (retardSwval == 1 || retardOn == 1))
  {
    retardOn = 1;
    retardcount = retardcount + 1;
  }

  else if (retardcount < 120 && (retardSwval == 1 || retardOn == 1))
  {
    retardOn = 1;

  }

  else
  {
    retardOn = 0; 
    // sumwinSwval = 0;
    retardcount = 0;
  }  



  // end summer to winter change clocks go back#################################  





  // Display of Title and 30 second pulse correction on row 01 ##############################




  if (retardcount > 0 || retardcount == 119 ) //Prints correction pulse number
  {
    lcd.setCursor(0,1); 
    lcd.print("Winter Retard  ");
    lcd.setCursor(15,1);



    retard(retardcount); // add leading 0 <99
    retardtens(retardcount); // add another leading 0 less than 10
    lcd.print(retardcount);
  }
  else if (retardcount == 120 )  //Prints blank when correction pulse is on last number
  {
    lcd.setCursor(0,1); 
    lcd.print("                    ");
    // lcd.print(retardcount);
  } 


  else if (seconds >= 0 && seconds <= 5 && pulsecount == 0) // Ignored while clock is correcting forward or retarding
  {

    lcd.setCursor(0,1); //Start at character 0 on line 0
    lcd.print("  DCF77 Dial Clock  ");      

  }
  else if(seconds > 05 && seconds <= 10 && pulsecount == 0) // Ignored while clock is correcting forward or retarding
  {
    lcd.setCursor(0,1); //Start at character 0 on line 0
    //lcd.print(" DCF77 Master Clock ");  
    lcd.print(" Brett Oliver v11.0 ");
  }

  else if(seconds == 11 && pulsecount == 0) // Ignored while clock is correcting forward or retarding
  {
    lcd.setCursor(0,1); //Start at character 0 on line 0

    lcd.print("                    ");
  }

  else if(seconds > 11 && seconds <= 13 && pulsecount == 0) // Ignored while clock is correcting forward or retarding
  {
    lcd.setCursor(0,1); //Start at character 0 on line 0

    // lcd.print("       Pulses       ");
    lcd.print("   1 Second Clocks  ");

  }



  else if(seconds > 13 && seconds <=59 && pulsecount == 0) // Ignored while clock is correcting forward or retarding
  {
    lcd.setCursor(0,1); //Start at character 0 on line 0
    lcd.print("  Slow "); // miss pulse detected so extra 1 second motor pulse added
    lcd.print(misscount);

    lcd.print(" ");
    lcd.print("   Fast ");        
    lcd.print(extracount);
  }

  else if (pulsecount > 0 || pulsecount == 119 ) //Prints correction pulse number
  {
    lcd.setCursor(0,1); 
    lcd.print("Summer Advance ");
    lcd.setCursor(15,1);
    //lcd.print(pulsecount);

    advance(pulsecount); // add leading 0 <99
    advancetens(pulsecount); // add another leading 0 less than 10
    lcd.print(pulsecount);
  }
  else if (pulsecount == 120 )  //Prints blank when correction pulse is on last number
  {
    lcd.setCursor(0,1); 
    lcd.print("                    ");
    //lcd.print(pulsecount);
  } 









  // sum win test print
  //sumwinSwval = digitalRead(sumwinSw);   // read sumwinSw switch
  /* Serial.print(" Sum Win Pulse No ");
   Serial.print(pulsecount);
   Serial.print(" ");
   
   Serial.print("Sum Win SW ");
   Serial.print(sumwinSwval);
   Serial.print(" ");
   Serial.print("Pulse On ");
   Serial.print(pulseOn);
   Serial.print(" ");
   Serial.print("Retard On ");
   Serial.print(retardOn);
   Serial.print(" ");
   Serial.print("Retard Count ");
   Serial.print(retardcount);
   Serial.print(" ");
   Serial.print("Summer Test ");
   Serial.print(summertest);
   Serial.print(" ");
   */

  // end sum win test print 
  //  

  // winter to summer change // clocks go forward#################################

  // End Display of Title and 30 second pulse correction on row 01 ##############################






  // 30 second clock pulses
  if ((retardOn == 0 && pulseOn ==0) && (seconds == 0 || seconds == 30)) // will only pulse if retardOn = 0 ( not in winter retard mode)
  {
    digitalWrite(led30, LOW);   // turn the LED on (HIGH is the voltage level)
    //  Serial.println(" Normal 30 sec ");    

  }

  else if ((retardOn == 0 && pulseOn ==0) && (seconds != 0 || seconds !=30)) // will only pulse if retardOn = 0 ( not in winter retard mode
  {
    digitalWrite(led30, HIGH);   // turn the LED off (LOW is the voltage level)  

  }
  // end 30 second clock pulses
/*
  // 1 min pulse
  {
    if (seconds == 0) 
    {
      digitalWrite(led1min, HIGH);   // turn the LED on (HIGH is the voltage level)

    }      

    else if(seconds != 0)

      digitalWrite(led1min, LOW);   // turn the LED off (LOW is the voltage level)  

  }


  // 1 hour pulse
  {
    if (minutes == 0 && seconds== 0) 
    {
      digitalWrite(led1hr, HIGH);   // turn the LED on (HIGH is the voltage level)

    }      

    else if (minutes != 0 || seconds !=0)

      digitalWrite(led1hr, LOW);   // turn the LED off (LOW is the voltage level)  

  }
*/
 /*
  // 1 day pulse
  {
    if (hours == 0 && minutes == 0 && seconds == 0) 
    {
      digitalWrite(led1day, HIGH);   // turn the LED on (HIGH is the voltage level)

    }      

    else if(hours != 0 || minutes != 0 || seconds != 0)

      digitalWrite(led1day, LOW);   // turn the LED off (LOW is the voltage level)  

  }
*/
} 






void secondsmotor (){

  if (quartzmotor1 == LOW)
  { 
    quartzmotor1 = HIGH; 
  }
  else
    quartzmotor1 = LOW;
  {
    digitalWrite(quartz01, quartzmotor1); // set the quartz motor drive 7 pin
    digitalWrite(quartz03, quartzmotor1); // set the quartz motor drive 5 pin   
  }

  if (quartzmotor2 == HIGH)
  { 
    quartzmotor2 = LOW;
  }
  else
    quartzmotor2 = HIGH;
  {
    digitalWrite(quartz02, quartzmotor2); // set the quartz motor drive 8 pin
    digitalWrite(quartz04, quartzmotor2); // set the quartz motor drive 6 pin  
  }

}

//**********************

//add extra quartz pulse

// if (secsmiss > 1) // if >1 pulse has been missed so extra quartz pulse is added here





// ################################################################################

void segIntensity(int intensity){

  if(intensity < 10)  
    lcd.print("0"); // Print hour on first line
  lcd.print(intensity);
}

// end

void advance(int pulsecount){ // leading 0  on pulse count
  if (pulsecount < 100)

    lcd.print("0"); 

}

void advancetens(int pulsecount){ // leading 0  on pulse count
  if (pulsecount <10)

    lcd.print("0"); 

}
//******************************

void retard(int retardcount){ // leading 0  on pulse count
  if (retardcount < 100)

    lcd.print("0"); 

}

void retardtens(int retardcount){ // leading 0  on pulse count
  if (retardcount <10)

    lcd.print("0"); 

}











void monthzero(int monthval) { // leading zero on month value
  if (monthval < 10)

    lcd.print("0"); // Print hour on first line
  lcd.print(monthval);
}


void dayzero(int dayval) { // leading zero on day value
  if (dayval < 10)

    lcd.print("0"); // Print hour on first line
  lcd.print(dayval);
}



// intensity of 7 segment display
void intensityValue() { 

 // if (ldrValue < 40)
//  {
  //  intensity = 0;
//  }
  if (ldrValue >= 0 && ldrValue < 50)
  {
    intensity = 1;
  }


  else if (ldrValue >= 50 && ldrValue < 85)
  {
    intensity = 2;
  }

  else if (ldrValue >= 85 && ldrValue < 120)
  {
    intensity = 3;
  }

  else if (ldrValue >= 120 && ldrValue < 155)
  {
    intensity = 4;
  }


  else if (ldrValue >= 155 && ldrValue < 190)
  {
    intensity = 5;
  }


  else if (ldrValue >= 190 && ldrValue < 225)
  {
    intensity = 6;
  }


  else if (ldrValue >= 225 && ldrValue < 260 )
  {
    intensity = 7;
  }



  else if (ldrValue >= 260 && ldrValue < 295)
  {
    intensity = 8;
  }



  else if (ldrValue >= 295 && ldrValue < 330)
  {
    intensity = 9;
  }



  else if (ldrValue >= 330 && ldrValue < 365)
  {
    intensity = 10;
  }



  else if (ldrValue >= 365 && ldrValue < 400)
  {
    intensity = 11;
  }
  else if (ldrValue >= 400 && ldrValue < 435)
  {
    intensity = 12;
  }
  else if (ldrValue >= 435 && ldrValue < 470)
  {
    intensity = 13;
  }
  else if (ldrValue >= 470 && ldrValue < 505)
  {
    intensity = 14;
  }


  else if (ldrValue >= 505)
  {
    intensity = 15;
  }
} 




void blankrow3() {
  lcd.setCursor(0,3);
  lcd.print("               "); 
}





void signalmatch() {

  signalQual = DCF77_Clock::get_prediction_match();
  if(signalQual == 255 || signalQual == 0 )
  {
    signalQual = 00;
  }
  else
  {
    signalQual = signalQual * 2;
  }
  lcd.setCursor(0,3);
  lcd.print("Sig Match ");
  lcd.print(signalQual);
  lcd.print("%");
}



void precision() {
  lcd.setCursor(0,3);
  lcd.print("Accuracy ");
  lcd.print(DCF77_Frequency_Control::get_confirmed_precision());
  lcd.print("Hz "); 
}

void freqadj() {
  lcd.setCursor(0,3);
 // lcd.print("Qtz ");
  lcd.print(16000000L - DCF77_1_Khz_Generator::read_adjustment());
  lcd.print("Hz"); 
}






